/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-10-29 14:38:16.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.test;

import cn.com.qmth.examcloud.core.print.entity.ProjectBackupSetting;
import cn.com.qmth.examcloud.core.print.entity.ProjectOtherSetting;
import cn.com.qmth.examcloud.core.print.enums.BackupGroupType;
import cn.com.qmth.examcloud.core.print.service.ProjectBackupSettingService;
import cn.com.qmth.examcloud.core.print.service.ProjectOtherSettingService;
import cn.com.qmth.examcloud.core.print.service.bean.printingproject.ProjectBackupSettingInfo;
import cn.com.qmth.examcloud.core.print.service.bean.printingproject.ProjectOtherSettingInfo;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @author: fengdesheng
 * @since: 2018/10/17
 */
public class ProjectSettingServiceTest extends BaseTest {
    @Autowired
    private ProjectBackupSettingService projectBackupSettingService;
    @Autowired
    private ProjectOtherSettingService projectOtherSettingService;
    private final Long projectId = 1L;

    @Test
    public void saveProjectBackupSettingTest() throws Exception {
        ProjectBackupSettingInfo setting = new ProjectBackupSettingInfo();
        setting.setProjectId(projectId);

        setting.setNeedEachPkg(true);
        setting.setEachPkgPercent(0.5D);
        setting.setEachPkgMax(0.5D);
        setting.setEachPkgMin(0.5D);

        setting.setNeedAlonePkg(true);
        setting.setGroupType(BackupGroupType.EXAM_SITE);
        setting.setAlonePkgPercent(0.5D);
        setting.setAlonePkgMax(0.5D);
        setting.setAlonePkgMin(0.5D);
        projectBackupSettingService.saveProjectBackupSetting(setting);
    }

    @Test
    public void getProjectBackupSettingTest() throws Exception {
        ProjectBackupSetting setting = projectBackupSettingService.getProjectBackupSettingById(projectId);
        System.out.println(jsonMapper.toJson(setting));
    }

    @Test
    public void removeProjectBackupSettingTest() throws Exception {
        projectBackupSettingService.removeProjectBackupSettingById(1L);
    }

    @Test
    public void saveProjectOtherSettingTest() throws Exception {
        ProjectOtherSettingInfo setting = new ProjectOtherSettingInfo();
        setting.setId(1L);
        setting.setProjectId(projectId);
        setting.setRemark("test");
        projectOtherSettingService.saveProjectOtherSetting(setting);
        //projectOtherSettingService.deleteProjectOtherSettingById(1L);
    }

    @Test
    public void getProjectOtherSettingTest() throws Exception {
        List<ProjectOtherSetting> settings = projectOtherSettingService.getProjectOtherSettingList(projectId);
        System.out.println(jsonMapper.toJson(settings));

        ProjectOtherSetting setting = projectOtherSettingService.getProjectOtherSettingById(1L);
        System.out.println(jsonMapper.toJson(setting));
    }

}